import json
import random
import time
import os

def generate_data():
    body_parts = [
    'Pelvis', 'L5', 'L3', 'T12', 'T8', 'Neck', 'Head',
    'Right Shoulder', 'Right Upper Arm', 'Right Forearm', 'Right Hand',
    'Left Shoulder', 'Left Upper Arm', 'Left Forearm', 'Left Hand',
    'Right Upper Leg', 'Right Lower Leg', 'Right Foot', 'Right Toe',
    'Left Upper Leg', 'Left Lower Leg', 'Left Foot', 'Left Toe'
    ]

    # Generating 1 frame of data
    data = {'list': []}
    for part in body_parts:
        frame = {
            'name': (part),
            'position': {
                'x': random.uniform(-1, 1),
                'y': random.uniform(-1, 1),
                'z': random.uniform(-1, 1)
            }
        }
        data['list'].append(frame)
    return data

def write_to_file(filename, data):
  try:
    script_dir = os.path.dirname(__file__)
    full_path = os.path.join(script_dir, filename)
    
    with open(full_path, 'x') as file:  # Try opening in exclusive creation mode ('x')
      file.write(json.dumps(data) + '\n')
  except FileExistsError:  # If the file already exists
    with open(full_path, 'a') as file:
      file.write(json.dumps(data) + '\n')

if __name__ == "__main__":
    print('Simulating incoming data... CTRL+C to finish')
    filename = 'input_data.json'
    while True:
        data = generate_data()
        write_to_file(filename, data)
        time.sleep(0.2)
